//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  vector<int> coll;
  list<int> searchcoll;

  INSERT_ELEMENTS(coll,1,11);
  INSERT_ELEMENTS(searchcoll,3,5);

  PRINT_ELEMENTS(coll,      ":\n");
  PRINT_ELEMENTS(searchcoll,":\n");

  //   coll     searchcoll
  vector<int>::iterator pos;
  pos = find_first_of (coll.begin(), coll.end(),     // 
                       searchcoll.begin(),   //   
                       searchcoll.end());    //   
  cout << ToRus("     \n")
       << distance(coll.begin(),pos) + 1
       << ToRus("   .") << endl;

  //   coll   search   searchcoll
  vector<int>::reverse_iterator rpos;
  rpos = find_first_of (coll.rbegin(), coll.rend(),  // 
                        searchcoll.begin(),  //   
                        searchcoll.end());   //   
  cout << ToRus("     \n")
       << distance(coll.begin(),rpos.base())
       << ToRus("   .") << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------